         title    Listview

         .586
         .model   flat, STDCALL
         option   casemap: none   ; case sensitive

         include  AsmEdit.inc

.const
ClassName      db  'ListViewWindow',0
AppName        db  'A ListView Control',0
ListViewClass  db  'SysListView32',0
FontMS         db  'MS Sans Serif',0

szColName      db  'Filename',0
szError1       db  'Could not find an exe in this Folder.', 0Dh,0Ah,0Dh,0Ah
               db  'Or there is more then one exe in this Folder and could', 0Dh,0Ah
               db  'not find one that matches the Folder name', 0Dh,0Ah
               db  'or the displayed File name.',0
szMsg01        db  'This will delete the seleted file', 0Dh,0Ah
               db  'Do you wish to continue?',0

szAll          db  '*.*',0
szExe          db  '.exe',0
szRootPath     db  'C:\',0
szSlashB       db  '\',0
szPointer      db  'Pointers\',0
szPtr          db  '.ptr',0

.data?
;hInst          dd  ?
hFontM         dd  ?
hImageListS    dd  ?
Texe           dd  ?
Tdll           dd  ?
Tlib           dd  ?
Tinc           dd  ?
szPath         db  256 dup(?)
szProjName     db  64  dup(?)

.data
lf             LOGFONT     <>
rect           RECT        <>

.code

;=========================================================================
; InitListView PROCEDURE
;=========================================================================
InitListView  proc  hinst:DWORD, hwnd:DWORD, ListType
LOCAL    sfi:SHFILEINFO
LOCAL    lvc:LV_COLUMN
LOCAL    SavList:DWORD, hBitmap

; LVS_SHAREIMAGELISTS or
      .if ListType
          MOVmd     SavList, hWndList
      .endif
      INVOKE     CreateWindowEx, WS_EX_CLIENTEDGE, addr ListViewClass, NULL,\
                 WS_CHILD or WS_VISIBLE or LVS_REPORT or\
                 LVS_SORTASCENDING or LVS_SHOWSELALWAYS or WS_CLIPSIBLINGS,\
                 0, 0, 0, 0, hwnd, ID_LISTVIEW, hinst, NULL
         mov     hWndList, eax

;         mov     eax, LVS_EX_FULLROWSELECT or LVS_EX_HEADERDRAGDROP or\
;                      LVS_EX_SUBITEMIMAGES or LVS_EX_GRIDLINES

;         mov     eax, LVS_EX_FULLROWSELECT ;or LVS_EX_GRIDLINES

;      INVOKE     SendMessage, hWndList, LVM_SETEXTENDEDLISTVIEWSTYLE, 0, eax


      INVOKE     ImageList_Create, 16, 16, ILC_COLOR32, 8, 0
         mov     hImageListS, eax
      INVOKE     LoadBitmap, hInst, 800
         mov     hBitmap, eax
      INVOKE     ImageList_Add, hImageListS, hBitmap, NULL
      INVOKE     DeleteObject, hBitmap
      INVOKE     SendMessage, hWndList, LVM_SETIMAGELIST, LVSIL_SMALL, hImageListS

;---------- [Remove the comments below if you want system icon's] ----------
;      INVOKE     SHGetFileInfo, addr szRootPath, 0, addr sfi, sizeof SHFILEINFO,\
;                 SHGFI_SYSICONINDEX or SHGFI_SMALLICON
;         mov     hImageListS, eax
;      INVOKE     SendMessage, hWndList, LVM_SETIMAGELIST, LVSIL_SMALL, hImageListS

      .if !hFontM
         INVOKE     lstrcpy, addr lf.lfFaceName, addr FontMS
            mov     lf.lfHeight, -12
            mov     lf.lfWeight, 400 ;600
         INVOKE     CreateFontIndirect, addr lf
            mov     hFontM, eax    ; Listview font
      .endif

      INVOKE     SendMessage, hWndList, WM_SETFONT, hFontM, 1
      INVOKE     SendMessage, hWndList, LVM_SETTEXTCOLOR, 0, TextCM
      INVOKE     SendMessage, hWndList, LVM_SETTEXTBKCOLOR, 0, BackGCM
      INVOKE     SendMessage, hWndList, LVM_SETBKCOLOR, 0, BackGCM

         mov     lvc.imask, LVCF_TEXT or LVCF_WIDTH
         mov     lvc.pszText, offset szColName
         mov     lvc.lx, 129
      INVOKE     SendMessage, hWndList, LVM_INSERTCOLUMN, 0, addr lvc
      .if ListType
          MOVmd     hWndListP, SavList
      .endif
         ret
InitListView  endp

;=========================================================================
; Read the file PROCEDURE
;=========================================================================
ReadTheFile  proc  uses edi  Input:DWORD
LOCAL    FindData:WIN32_FIND_DATA
LOCAL    lvi:LV_ITEM
LOCAL    hFind:DWORD, Pointer, Match
LOCAL    szBuff[256]:BYTE, szBuff1[64], szFolder[64], szFolderE[64], szFileNameE[64]

         and     Pointer, 0
         and     Match, 0
         and     Texe, 0
         and     Tdll, 0
         and     Tlib, 0
         and     Tinc, 0
         mov     byte ptr szFolderE, 0
         mov     byte ptr szFileNameE, 0

;---------- [Check if in a Root directory] ----------
      INVOKE     lstrcpy, addr szPath, Input
      INVOKE     lstrlen, addr szPath
         dec     eax
      .while (eax)
            dec     eax
         .if byte ptr szPath[eax] == '\'
            .if byte ptr szPath[eax-1] == ':'
;DSPValue hWnd, 1234, 1, 'm'
;INVOKE     MessageBox, NULL, addr szProjectP, addr AppName, MB_OK
            .endif
            .break
         .endif
      .endw

      .if !Run
         INVOKE     lstrcpy, addr szBuff, addr RootDir
         INVOKE     lstrcat, addr szBuff, addr szPointer
         .if ProjOn
            INVOKE     SendMessage, hWndListP, LVM_DELETEALLITEMS, 0, 0
            INVOKE     lstrcat, addr szBuff, addr szProjectP
         .else
            INVOKE     SendMessage, hWndList, LVM_DELETEALLITEMS, 0, 0
            INVOKE     lstrcat, addr szBuff, addr szProject
         .endif
         INVOKE     lstrcat, addr szBuff, addr szPtr

;---------- [See if there is a pointer file] ----------
         INVOKE     FindFirstFile, addr szBuff, addr FindData
         .if eax != INVALID_HANDLE_VALUE
            INVOKE     FindClose, eax
               mov     Pointer, 1
         .endif
      .endif

      INVOKE     lstrcpy, addr szBuff, Input
      INVOKE     lstrcpy, addr szPath, addr szBuff
      INVOKE     lstrcat, addr szBuff, addr szAll

;---------- [Check for mult exe's] ----------
      .if Run
         INVOKE     FindFirstFile, addr szBuff, addr FindData
         .if eax != INVALID_HANDLE_VALUE
               mov     hFind, eax
            .while (eax)
               .if byte ptr FindData.cFileName != '.'
                  INVOKE     lstrcpy, addr szBuff1, addr FindData.cFileName
                  INVOKE     lstrlen, addr szBuff1
                     sub     eax, 3
                  .if byte ptr szBuff1[eax] == 'e' && byte ptr szBuff1[eax+2] == 'e' ||\
                      byte ptr szBuff1[eax] == 'E' && byte ptr szBuff1[eax+2] == 'E'
                        inc     Texe
                  .endif
               .endif
               INVOKE     FindNextFile, hFind, addr FindData
            .endw
            INVOKE     FindClose, hFind
         .endif

;---------- [Get the folder name] ----------
         INVOKE     lstrlen, addr szPath
           push     eax
            dec     eax
         .while (eax)
               dec     eax
            .if byte ptr szPath[eax] == '\'
               .break
            .endif
         .endw
            pop     ecx
            sub     ecx, eax
            inc     eax
            dec     ecx
         INVOKE     lstrcpyn, addr szFolder, addr szPath[eax], ecx

INVOKE     lstrcpy, addr szFolder, addr szProjectP

         INVOKE     lstrcpy, addr szProjName, addr szFolder
         INVOKE     lstrcpy, addr szFolderE, addr szFolder
         INVOKE     lstrcat, addr szFolderE, addr szExe
         .if Run == 1
            INVOKE     lstrlen, addr FileName
               sub     eax, 3
            .if byte ptr FileName[eax] == '.' || byte ptr FileName[eax-1] == '.'
               .if byte ptr FileName[eax] == '.'
                     inc     eax
               .endif
               INVOKE     lstrcpyn, addr szFileNameE, addr FileName, eax
               INVOKE     lstrcat, addr szFileNameE, addr szExe
            .endif
         .endif
      .endif

      .if Run == 4
            ret
      .endif
;DSPValue hWnd, 7777, 1, 'm'
;INVOKE     MessageBox, NULL, addr szFolderE, addr AppName, MB_OK
;INVOKE     MessageBox, NULL, addr szFileNameE, addr AppName, MB_OK

      INVOKE     FindFirstFile, addr szBuff, addr FindData
      .if eax != INVALID_HANDLE_VALUE
            mov     hFind, eax
            xor     edi, edi
         .while eax != 0
            .if byte ptr FindData.cFileName != '.'
               .if (FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
               .else
                  INVOKE     lstrcpy, addr szBuff1, addr FindData.cFileName
                  INVOKE     lstrlen, addr szBuff1
                  .while (eax)
                     .if byte ptr szBuff1[eax] == '.'
                        .break
                     .endif
                        dec     eax
                  .endw
                  .if eax
                        inc     eax
                     .if byte ptr szBuff1[eax] >= 'A' && byte ptr szBuff1[eax] <= 'Z'
                           add     byte ptr szBuff1[eax], 20h
                     .endif
                     .if byte ptr szBuff1[eax+1] >= 'A' && byte ptr szBuff1[eax+1] <= 'Z'
                           add     byte ptr szBuff1[eax+1], 20h
                     .endif
                     .if byte ptr szBuff1[eax+2] >= 'A' && byte ptr szBuff1[eax+2] <= 'Z'
                           add     byte ptr szBuff1[eax+2], 20h
                     .endif

                     .if Run                ; Find the exe file
                        .if byte ptr szBuff1[eax] == 'e' && byte ptr szBuff1[eax+1] == 'x' &&\
                            byte ptr szBuff1[eax+2] == 'e'
                           .if Texe > 1 ; Mult exe's
                              INVOKE     lstrcmpi, addr szFolderE, addr FindData.cFileName
                              .if eax == 0
                                    inc     Match
                                 .if Run == 1
                                    INVOKE     lstrcat, Input, addr FindData.cFileName
                                    .break
                                 .endif
                              .else

                                 INVOKE     lstrcmpi, addr szFileNameE, addr FindData.cFileName
                                 .if eax == 0
                                       inc     Match
                                    .if Run == 1
                                       INVOKE     lstrcat, Input, addr FindData.cFileName
                                       .break
                                    .endif
                                 .else
                                       jmp     Pass
                                 .endif

                              .endif
                           .else
                                 inc     Match
                              .if Run == 1
                                 INVOKE     lstrcat, Input, addr FindData.cFileName
                                 .break
                              .endif
                                 jmp     Pass
                           .endif

                        .elseif Run == 2    ; Copy
                             push     eax
                           INVOKE     lstrlen, addr FindData.cFileName
                              sub     eax, 3
                           INVOKE     lstrcpyn, addr szBuff, addr FindData.cFileName, eax
                           INVOKE     lstrcmpi, addr szFolder, addr szBuff
                           .if eax != 0
                                 pop     eax
                                 jmp     Pass
                           .endif
                              pop     eax
                           .if byte ptr szBuff1[eax] == 'd' && byte ptr szBuff1[eax+1] == 'l' &&\
                               byte ptr szBuff1[eax+2] == 'l'
                                 inc     Tdll
                           .elseif byte ptr szBuff1[eax] == 'l' && byte ptr szBuff1[eax+1] == 'i' &&\
                               byte ptr szBuff1[eax+2] == 'b'
                                 inc     Tlib
                           .elseif byte ptr szBuff1[eax] == 'i' && byte ptr szBuff1[eax+1] == 'n' &&\
                               byte ptr szBuff1[eax+2] == 'c'
                                 inc     Tinc
                           .else
                                 jmp     Pass
                           .endif          
;                           INVOKE     lstrcat, Input, addr FindData.cFileName
                              inc     Match
                        .else
                        .endif
                           jmp     Pass
                     .endif

                     .if Projects ;|| ProjOn     ; Get the files for the Listview
                        .if byte ptr szBuff1[eax] == 'a' && byte ptr szBuff1[eax+1] == 's' ||\
                            byte ptr szBuff1[eax] == 'r' && byte ptr szBuff1[eax+1] == 'c'
                        .elseif byte ptr szBuff1[eax] == 'i' && byte ptr szBuff1[eax+1] == 'n' ||\
                            byte ptr szBuff1[eax] == 'd' && byte ptr szBuff1[eax+1] == 'e' ||\
                            byte ptr szBuff1[eax] == 'b' && byte ptr szBuff1[eax+1] == 'a'
                        .else
                              jmp     Pass
                        .endif
                     .endif

                     .if byte ptr szBuff1[eax] == 'a' && byte ptr szBuff1[eax+1] == 's'
                           mov     ecx, 2
                     .elseif byte ptr szBuff1[eax] == 'r' && byte ptr szBuff1[eax+1] == 'c'
                           mov     ecx, 5
                     .elseif byte ptr szBuff1[eax] == 'i' && byte ptr szBuff1[eax+1] == 'n'
                           mov     ecx, 6
                     .elseif byte ptr szBuff1[eax] == 'd' && byte ptr szBuff1[eax+1] == 'e'
                           mov     ecx, 3
                     .else
                           mov     ecx, 4
                     .endif

                     INVOKE     LoadListView, edi, addr FindData, ecx
                        inc     edi
                  .endif
               .endif
            .endif
Pass:
            INVOKE     FindNextFile, hFind, addr FindData
         .endw

;---------- [Load the Pointer item if available] ----------
         .if !Run && Pointer ;&& ProjOn
INVOKE     RtlZeroMemory, addr lvi, sizeof lvi

               mov     lvi.imask, LVIF_TEXT or LVIF_IMAGE or LVIF_PARAM
               mov     lvi.iItem, edi
               mov     lvi.lParam, edi
               mov     lvi.iSubItem, 0
            .if ProjOn
               INVOKE     lstrcpy, addr szBuff1, addr szProjectP
            .else
               INVOKE     lstrcpy, addr szBuff1, addr szProject
            .endif
            INVOKE     lstrcat, addr szBuff1, addr szPtr
               lea     eax, szBuff1
               mov     lvi.pszText, eax
               mov     lvi.iImage, 7
            .if ProjOn
               INVOKE     SendMessage, hWndListP, LVM_INSERTITEM, 0, addr lvi
            .else
               INVOKE     SendMessage, hWndList, LVM_INSERTITEM, 0, addr lvi
            .endif
         .endif

         INVOKE     FindClose, hFind
         .if Run && !Match
            INVOKE     MessageBox, NULL, addr szError1, addr szFolder, MB_OK or MB_ICONWARNING
         .endif
      .endif

         ret
ReadTheFile  endp

;=========================================================================
; Load the ListView with the file data PROCEDURE
;=========================================================================
LoadListView proc  uses ebx edx edi  row:DWORD, lpFind, TypeF
LOCAL    lvi:LV_ITEM
LOCAL    szBuff0[64]:BYTE

         mov     edi, lpFind

INVOKE     RtlZeroMemory, addr lvi, sizeof lvi

;---------- [Load the list items] ----------
         mov     lvi.imask, LVIF_TEXT or LVIF_IMAGE or LVIF_PARAM
        push     row
         pop     lvi.iItem
        push     row
         pop     lvi.lParam
         mov     lvi.iSubItem, 0
         mov     lvi.cchTextMax, 255
         lea     eax, [edi.WIN32_FIND_DATA].cFileName
         mov     lvi.pszText, eax
         mov     eax, TypeF
         mov     lvi.iImage, eax
      .if ProjOn
         INVOKE     SendMessage, hWndListP, LVM_INSERTITEM, 0, addr lvi
      .else
         INVOKE     SendMessage, hWndList, LVM_INSERTITEM, 0, addr lvi
      .endif
         ret
LoadListView endp

;==========================================================================
; Builds the path to display in the Edit window from the Listview PROCEDURE
;==========================================================================
DisplayFileName proc  ;uses ebx
LOCAL    lvi:LV_ITEM
LOCAL    tvi:TV_ITEM
LOCAL    SavItem:DWORD
LOCAL    ShFileOp:SHFILEOPSTRUCT
LOCAL    szBuff[256]:BYTE, szCurDir[256]:BYTE, szName[64]:BYTE

;      INVOKE     lstrcpy, addr szPath, addr szLoadPath
         mov     tvi.imask, TVIF_HANDLE or TVIF_TEXT
      .if ProjOn
         INVOKE     SendMessage, hWndListP, LVM_GETNEXTITEM, -1, LVNI_FOCUSED
      .else
         INVOKE     SendMessage, hWndList, LVM_GETNEXTITEM, -1, LVNI_FOCUSED
      .endif
      .if eax == -1
            ret
      .endif
mov     SavItem, eax
         mov     lvi.iItem, eax
         mov     lvi.iSubItem, 0
         mov     lvi.imask, LVIF_TEXT or LVIF_STATE
         lea     eax, szName
         mov     lvi.pszText, eax
         mov     lvi.cchTextMax, 256

      .if ProjOn
         INVOKE     SendMessage, hWndTreeP, TVM_GETNEXTITEM, TVGN_CARET, hItemP
      .else
         INVOKE     SendMessage, hWndTree, TVM_GETNEXTITEM, TVGN_CARET, hItem
      .endif


         mov     tvi.hItem, eax
         lea     eax, szProjectP
         mov     tvi.pszText, eax
         mov     tvi.cchTextMax, 63

      .if ProjOn
         INVOKE     SendMessage, hWndListP, LVM_GETITEM, 0, addr lvi
         INVOKE     SendMessage, hWndTreeP, TVM_GETITEM, 0, addr tvi

      .else
         INVOKE     SendMessage, hWndList, LVM_GETITEM, 0, addr lvi
         INVOKE     SendMessage, hWndTree, TVM_GETITEM, 0, addr tvi
      .endif

      INVOKE     lstrlen, addr szName
      .if byte ptr szName[eax-3] == 'p' && byte ptr szName[eax-1] == 'r'
         INVOKE     lstrcpy, addr szBuff, addr RootDir
         INVOKE     lstrcat, addr szBuff, addr szPointer
      .elseif ProjOn
         INVOKE     lstrcpy, addr szBuff, addr szLoadPathP
      .else
         INVOKE     lstrcpy, addr szBuff, addr szLoadPath
      .endif

;---------- [Delete File] ----------
      .if Run == 75
         INVOKE     MessageBox, NULL, addr szMsg01, addr szName, MB_YESNO or\
                    MB_ICONWARNING or MB_TASKMODAL
         .if eax == IDNO
               jmp     Ret0
         .endif
         INVOKE     RtlZeroMemory, addr ShFileOp, sizeof ShFileOp
         INVOKE     GetCurrentDirectory, lengthof szCurDir, addr szCurDir
         INVOKE     SetCurrentDirectory, addr szBuff

         INVOKE     lstrlen, addr szName
            inc     eax
            mov     szName[eax], 0       ; Insert additional terminator
            mov     ShFileOp.wFunc, FO_DELETE
            mov     ShFileOp.hwnd, 0     ; If 0, then no parent can task switch away
            lea     eax, szName
            mov     ShFileOp.pFrom, eax
            mov     ShFileOp.fFlags, FOF_SILENT or FOF_NOCONFIRMATION or FOF_NOCONFIRMMKDIR
         INVOKE     SHFileOperation, addr ShFileOp
         .if eax != 0
;            INVOKE     MessageBox, NULL, addr szError9, addr pTitle, MB_OK or MB_ICONWARNING
         .else
            .if ProjOn
               INVOKE     SendMessage, hWndListP, LVM_DELETEITEM, SavItem, 0
            .else
               INVOKE     SendMessage, hWndList, LVM_DELETEITEM, SavItem, 0
            .endif
         .endif
            INVOKE     SetCurrentDirectory, addr szCurDir
               ret
      .endif

      INVOKE     lstrcat, addr szBuff, addr szName
      INVOKE     lstrcpy, addr PathName, addr szBuff
      INVOKE     lstrcpy, addr FileName, addr szName

Ret0:
         mov     eax, SavItem
         mov     lvi.iItem, eax
         mov     lvi.iSubItem, 0
         mov     lvi.imask, LVIF_STATE
         mov     lvi.state, 0 ;LVIS_FOCUSED  ;LVIS_FOCUSED or LVIS_SELECTED
         mov     lvi.stateMask, 0fh
      .if ProjOn
         INVOKE     SendMessage, hWndListP, LVM_SETITEMSTATE, SavItem, addr lvi
      .else
         INVOKE     SendMessage, hWndList, LVM_SETITEMSTATE, SavItem, addr lvi
      .endif

         xor     eax, eax
         ret
DisplayFileName endp

END
;INVOKE     MessageBox, NULL, addr szPath, addr AppName, MB_OK
