         title    Treeview

         .586
         .model   flat, STDCALL
         option   casemap: none   ; case sensitive

         include  AsmEdit.inc

.const
AppName         db  'Tree View',0
TreeClass       db  'SysTreeView32',0
szAsm           db  '.asm',0
szRootPath      db  'C:\',0
szError3        db  'The above path for the tree was not found!',0
szSlashB        db  '\',0
Parent          db  'Projects',0
szPtr           db  'Pointers\',0
PatnP           db  'Pointers\*.ptr',0
LibNameCP       db  'Create',0
FuncNameDP      db  'DelProj',0
szDeleteP       db  'This will delete the complete seleted Project.',0Dh,0Ah
                db  'Or just the Project name from the list.',0Dh,0Ah,0Dh,0Ah
                db  'Do you wish to continue?',0

.data?
;hInst           dd  ?       
hWndMain        dd  ?
hItem           dd  ?
hItemP          dd  ?
hTreeImageListP dd  ?
hTreeImageList  dd  ?
hMyComputer     dd  ?
hDrives         dd  27  dup(?)
szDrvLet        db  27  dup(?)
szListPath      db  256 dup(?)

hDir            dd  32  dup(?)
hParent         dd  ?
Lev             dd  ?
sw88            dd  ?

Test8           dd  ?
DeleteSW        dd  ?

.data
Loaded          dd  0
ExpCol          dd  0

;nmhdr    NMHDR               <?>

.code

;==========================
; InitTreeView PROCEDURE
;==========================
InitTreeView proc hinst:DWORD, hwnd:DWORD, TypeTree:DWORD, Refresh:DWORD
LOCAL    rect:RECT
LOCAL    lpsf:DWORD
LOCAL    tvis:TV_INSERTSTRUCT
LOCAL    FindData:WIN32_FIND_DATA
LOCAL    sfi:SHFILEINFO
LOCAL    szWork[256]:BYTE
LOCAL    hBitmap:DWORD, hFind, Cnt, Incr, SavItem

       MOVmd     sw88, Refresh
      .if Refresh
            and     hItemP, 0
         .if !TypeTree
               jmp     DoRefreshP
         .else
               jmp     Ret0
;               and     Loaded, 0
;            INVOKE     SendMessage, hWndTree, TVM_DELETEITEM, 0, TVI_ROOT
;               jmp     DoRefresh
         .endif
      .endif
.if Loaded
         and     hItemP, 0
.endif
      INVOKE     GetClientRect, hwnd, addr rect     
         mov     eax, rect.right
         shr     eax, 1
         dec     eax
;                 1, 25, 133, 150, hwnd, ID_TREEVIEW, hinst, NULL

      INVOKE     CreateWindowEx, WS_EX_CLIENTEDGE, addr TreeClass, 0,\
                 WS_CHILD or WS_VISIBLE or TVS_HASLINES or TVS_HASBUTTONS or\
                 TVS_LINESATROOT or TVS_SHOWSELALWAYS or WS_CLIPSIBLINGS,\
                 0, 0, 0, 0, hwnd, ID_TREEVIEW, hinst, NULL
        test     eax, eax     
          jz     Ret0
         mov     ecx, eax

        push     eax
      INVOKE     SendMessage, ecx, TVM_SETTEXTCOLOR, 0, TextCM
         pop     ecx
        push     ecx
      INVOKE     SendMessage, ecx, TVM_SETBKCOLOR, 0, BackGCM
         pop     ecx
        push     ecx
;      INVOKE     SendMessage, ecx, TVM_SETLINECOLOR, 0, BackGCM
;;      INVOKE     SendMessage, ecx, TVM_SETINSERTMARKCOLOR, 0, BackGCM
         pop     eax
      .if !TypeTree
            mov     hWndTreeP, eax
         INVOKE     SetWindowLong, hWndTreeP, GWL_ID, 2244
         INVOKE     ShowWindow, hWndTreeP, SW_HIDE
         INVOKE     ImageList_Create, 16, 16, ILC_COLOR16, 2, 5
            mov     hTreeImageListP, eax
         INVOKE     LoadBitmap, hinst, 800
            mov     hBitmap,eax
         INVOKE     ImageList_Add, hTreeImageListP, hBitmap, NULL
         INVOKE     DeleteObject, hBitmap
         INVOKE     SendMessage, hWndTreeP, TVM_SETIMAGELIST, 0, hTreeImageListP

DoRefreshP:
         INVOKE     LockWindowUpdate, hWnd          ; Lock Window to avoid flicker
            and     Lev, 0
         INVOKE     SendMessage, hWndTreeP, TVM_DELETEITEM, 0, TVI_ROOT
            mov     tvis.hParent, NULL
            mov     tvis.hInsertAfter, TVI_ROOT
            mov     tvis.item.imask, TVIF_TEXT or TVIF_IMAGE or TVIF_SELECTEDIMAGE
            mov     tvis.item.pszText, offset Parent
            mov     tvis.item.iImage, 0
            mov     tvis.item.iSelectedImage, 1
         INVOKE     SendMessage, hWndTreeP, TVM_INSERTITEM, 0, addr tvis
            mov     ecx, Lev
            mov     hDir[ecx*4], eax
            mov     hParent, eax

         INVOKE     lstrcpy, addr szWork, addr AsmRootDir
         INVOKE     lstrcat, addr szWork, addr PatnP
;INVOKE     MessageBox, NULL, addr szWork, addr AppName, MB_OK
         INVOKE     FindFirstFile, addr szWork, addr FindData
         .if eax == -1
            INVOKE     LockWindowUpdate, 0          ; Unock Window
               jmp     Ret0
         .endif
            mov     hFind, eax
            jmp     Addem

Getem:
         INVOKE     FindNextFile, hFind, addr FindData
           test     eax, eax
             jz     AllDone

Addem:
         INVOKE     lstrlen, addr FindData.cFileName
            sub     eax, 3
         INVOKE     lstrcpyn, addr szWork, addr FindData.cFileName, eax

            mov     eax, hParent
            mov     tvis.hParent, eax
            mov     tvis.hInsertAfter, TVI_LAST
            lea     eax, szWork
            mov     tvis.item.pszText, eax
         INVOKE     SendMessage, hWndTreeP, TVM_INSERTITEM, 0, addr tvis
            mov     SavItem, eax

         .if !hItemP
              push     eax
            INVOKE     lstrcmpi, addr szWork, addr szProjectP
               pop     ecx
            .if !eax
                  mov     hItemP, ecx
            .endif
         .endif

;---------- [Reload the Items in the Project Array] ----------
         .if sw88
               and     Incr, 0
             MOVmd     Cnt, ProjCnt
            .while (Cnt)
                  mov     esi, hProjArray
                  add     esi, Incr
                  add     esi, 9
                 push     esi
               INVOKE     lstrcmpi, addr szWork, esi
                  pop     esi
               .if !eax
                     sub     esi, 5
                     mov     eax, SavItem
                     mov     dword ptr[esi], eax
mov     byte ptr[esi+4], 1
               .endif
                  add     Incr, 36
                  dec     Cnt
            .endw
         .endif

            jmp     Getem
   
AllDone:
         INVOKE     FindClose, hFind
;         INVOKE     SendMessage, hWndTreeP, TVM_SETBKCOLOR, 0, BackGC
         INVOKE     SendMessage, hWndTreeP, TVM_EXPAND, TVE_EXPAND, hParent
         INVOKE     SendMessage, hWndTreeP, TVM_SORTCHILDREN, 0, hParent
         INVOKE     SendMessage, hWndTreeP, TVM_SELECTITEM, TVGN_CARET, hItemP ;hParent ;NULL ;hParent
         INVOKE     SendMessage, hWndTreeP, TVM_ENSUREVISIBLE, 0, hItemP
         INVOKE     LockWindowUpdate, 0          ; Unock Window
         .if hItemP ;&& !Refresh
               mov     Projects, 1
            INVOKE     TreeViewNotifyP, 55555, 0
         .endif
            jmp     Ret0

      .else
            mov     hWndTree, eax
      .endif

;---------- [Get the shell image list for the tree view] ----------
      INVOKE     SHGetFileInfo, addr szRootPath, 0, addr sfi, sizeof SHFILEINFO,\
                 SHGFI_SYSICONINDEX or SHGFI_SMALLICON
        test     eax, eax
          jz     Ret0
         mov     hTreeImageList, eax 
      INVOKE     SendMessage, hWndTree, TVM_SETIMAGELIST, 0, eax

DoRefresh:
      INVOKE     SHGetDesktopFolder, addr lpsf
        test     eax, eax
          js     Ret0

;---------- [Set the tree colors] ----------
;      INVOKE     SendMessage, hWndTree, TVM_SETTEXTCOLOR, 0, 00ffff00h
;      INVOKE     SendMessage, hWndTree, TVM_SETLINECOLOR, 0, 00ffff00h
;      INVOKE     SendMessage, hWndTree, TVM_SETBKCOLOR, 0, BackGC


;---------- [Fill the window with the root items] ----------
      INVOKE     UpdateTreeView, hWndTree, lpsf, 0, TVI_ROOT

;---------- [Free the shell folder pointer] ----------
         mov     eax, lpsf
         mov     eax,[eax]
      INVOKE     (IShellFolder ptr [eax]).Release, lpsf
      INVOKE     SetFocus, hWndTree
      INVOKE     SendMessage, hWndTree, TVM_SELECTITEM, TVGN_CARET, hMyComputer
      INVOKE     SendMessage, hWndTree, TVM_EXPAND, TVE_EXPAND, hMyComputer
         mov     Loaded, 44
.if Refresh && TypeTree
INVOKE     MessageBox, NULL, addr szLoadPath, addr AppName, MB_OK
;INVOKE     TreeBranch, addr szLoadPath
.endif
         jmp     Ret0   

Ret0:
;         xor     eax, eax

return:
         ret
InitTreeView endp

;-----------------------------------------------------------------------
UpdateTreeView proc uses ebx edx hwnd:DWORD, pshfParent, pidlFull, htreeParent
LOCAL    peidl:LPENUMIDLIST
LOCAL    pidl:DWORD
LOCAL    pidlFullCur:DWORD
LOCAL    ptvobj:LPTV_OBJDATA
LOCAL    tvis:TV_INSERTSTRUCT
LOCAL    sfi:SHFILEINFO
LOCAL    strret:STRRET
LOCAL    szWork[64]:BYTE
LOCAL    FirstItem:DWORD, dwAttr, Cnt, hItemI

         mov     edx, pshfParent
         mov     edx, [edx]
      INVOKE     (IShellFolder PTR [edx]).EnumObjects, pshfParent, hwnd, SHCONTF_FOLDERS or\
                 SHCONTF_NONFOLDERS or SHCONTF_INCLUDEHIDDEN, addr peidl
        test     eax, eax
          js     RetError
         mov     FirstItem, 1
         and     Cnt, 0
         mov     byte ptr szDrvLet, 0

ObjectLoop:
         mov     edx, peidl
         mov     edx, [edx]
      INVOKE     (IEnumIDList PTR [edx]).Next, peidl, 1, addr pidl, NULL
        test     eax, eax
          js     RetError
         cmp     eax, S_FALSE    ;no more items
          jz     RetOk

;---------- [Check to see if its a folder; if its a folder, add it to the tree] ----------
         mov     dwAttr, SFGAO_HASSUBFOLDER or SFGAO_FOLDER
         mov     edx, pshfParent
         mov     edx, [edx]
      INVOKE     (IShellFolder PTR [edx]).GetAttributesOf, pshfParent, 1, addr pidl, addr dwAttr
        test     eax, eax
          js     RetError

      .if dwAttr & (SFGAO_HASSUBFOLDER or SFGAO_FOLDER)
         .if dwAttr & SFGAO_FOLDER

            .if dwAttr == 20000000h
                  jmp     ObjectLoop
            .endif

;---------- [Save TV_OBJDATA] ----------
               mov     eax, pShellMalloc
               mov     eax, [eax]
            INVOKE     (IMalloc ptr [eax]).Alloc, pShellMalloc, sizeof TV_OBJDATA
              test     eax, eax
                jz     RetError
               mov     ptvobj, eax                         
               mov     ebx, eax            

            INVOKE     IDList_Combine, pidlFull, pidl  
               mov     (TV_OBJDATA PTR [ebx]).pidlFull, eax
               mov     pidlFullCur, eax
            INVOKE     IDList_CopyItem, pidl
               mov     (TV_OBJDATA PTR [ebx]).pidlRel, eax                    
               mov     eax, pshfParent
               mov     (TV_OBJDATA PTR [ebx]).pshfParent, eax
               mov     tvis.item.lParam, ebx

;---------- [Save tree item data] ----------
               mov     eax, htreeParent
               mov     tvis.hParent, eax
               mov     tvis.item.hItem, 0  
               mov     tvis.hInsertAfter, TVI_LAST
               mov     tvis.item.imask, TVIF_TEXT or TVIF_IMAGE or TVIF_SELECTEDIMAGE or TVIF_PARAM
            .if dwAttr & SFGAO_HASSUBFOLDER
                  mov     tvis.item.cChildren, TRUE
                   or     tvis.item.imask, TVIF_CHILDREN                         
            .endif

            INVOKE     SHGetFileInfo, pidlFullCur, 0, addr sfi, sizeof SHFILEINFO,
                       SHGFI_PIDL or SHGFI_DISPLAYNAME ; SHGFI_TYPENAME causes a problem
              test     eax,eax
                jz     RetError
               mov     tvis.item.cchTextMax, 255
               lea     eax, sfi.szDisplayName
               mov     tvis.item.pszText, eax

            INVOKE     lstrlen, eax
               sub     eax, 2
               mov     ebx, tvis.item.pszText
               add     ebx, eax
               mov     eax, [ebx]
            .if ax != '):' && !FirstItem && !Loaded
                  jmp     ObjectLoop
             .endif

            INVOKE     GetIcon, pidlFullCur, SHGFI_ICON
               mov     tvis.item.iImage, eax
            INVOKE     GetIcon, pidlFullCur, SHGFI_OPENICON 
               mov     tvis.item.iSelectedImage, eax

;---------- [Add item to the tree] ----------
            INVOKE     SendMessage, hwnd, TVM_INSERTITEM, 0, addr tvis
              test     eax, eax
                jz     RetError
               mov     hItemI, eax
            .if FirstItem == TRUE
                  mov     hMyComputer, eax
                  mov     FirstItem, 0
            .else

;---------- [Build the the drive list and drive handles] ----------
               INVOKE     lstrcpy, addr szWork, tvis.item.pszText
               INVOKE     lstrlen, addr szWork
                  sub     eax, 3
                  lea     ebx, szWork
                  add     ebx, eax
               .if word ptr [ebx+1] == '):'
                  INVOKE     lstrcpyn, addr szWork, ebx, 2
                     add     szWork, 32                             ; Convert to lower case
                  INVOKE     lstrcat, addr szDrvLet, addr szWork    ; szDrvLet = drive letters
                     .if byte ptr szWork > 96 && byte ptr szWork < 123  ; All drives
                           mov     ecx, hItemI
                           mov     eax, Cnt
                           dec     eax
                           mov     hDrives+[eax*4], ecx             ; Drive handles
                           inc     Cnt
                  .endif
               .endif
            .endif
         .endif     
      .endif
         mov     eax, pShellMalloc
         mov     eax, [eax]
      INVOKE     (IMalloc PTR [eax]).Free, pShellMalloc, pidl
         jmp     ObjectLoop

;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;RetOk:
         mov     eax, peidl
         mov     eax, [eax]
      INVOKE     (IEnumIDList PTR [eax]).Release, peidl

RetOk:
      INVOKE     lstrcat, addr szDrvLet, 0
         ret

RetError:
; Do Message
         ret
UpdateTreeView endp

;-----------------------------------------------------------------------
TreeViewNotifyP proc uses ebx edx esi edi hwnd:DWORD, lparam
LOCAL    pt:POINT
LOCAL    tvi:TV_ITEM
LOCAL    tvhti:TV_HITTESTINFO
LOCAL    FindData:WIN32_FIND_DATA
LOCAL    szWork[256]:BYTE, szBuff1[64]

      .if hwnd == 55555
         INVOKE     lstrcpy, addr szWork, addr szListPath
            jmp     FromFirst
      .endif
         mov     eax, lparam
         mov     ebx, (NM_TREEVIEW ptr [eax]).hdr.code
         mov     ecx, (NM_TREEVIEW ptr [eax]).itemNew.hItem
         mov     edx, (NMHDR ptr [eax]).code

      .if edx == NM_RCLICK
            jmp     RightClk
      .endif

      .if ebx == TVN_SELCHANGED
         .if ecx == hParent
            INVOKE     SendMessage, hWndTreeP, TVM_SELECTITEM, TVGN_CARET, NULL
               jmp     Ret0
         .endif

         .if DeleteSW == 4444
               and     DeleteSW, 0
;               mov     (NM_TREEVIEW ptr [eax]).action, TVIS_FOCUSED
         .endif

         .if !FromTab
              test     (NM_TREEVIEW ptr [eax]).action, TVIS_FOCUSED
                jz     Ret0
         .endif

            mov     hItemP, ecx
            mov     tvi.hItem, ecx
            mov     tvi.imask, TVIF_TEXT or TVIF_SELECTEDIMAGE
            lea     eax, szProjectP
            mov     tvi.pszText, eax
            mov     tvi.cchTextMax, 64
         INVOKE     SendMessage, hWndTreeP, TVM_GETITEM, NULL, addr tvi
           test     eax,eax
            jz      Ret0

FromFirst:
         INVOKE     lstrcpy, addr szWork, addr AsmRootDir
         INVOKE     lstrcat, addr szWork, addr szPtr
         INVOKE     lstrcat, addr szWork, addr szProjectP
         INVOKE     lstrcat, addr szWork, addr PatnP+10  ; = .ptr
            mov     ebx, hBuff
         INVOKE     lstrcpy, ebx, addr szWork
           call     readp
           test     eax, eax
             js     Ret0
            mov     ecx, bytesread        ; Bytes left to analyze
            mov     esi, fpMem            ; Start address in input buffer
            lea     edi, szWork
            xor     eax, eax
         .while (ecx)
            .if word ptr [esi] == ' :'
                  add     esi, 2
                  sub     ecx, 2
               .break
            .endif
               dec     ecx
               inc     esi
         .endw
         .if !ecx
               jmp     FreeEm
         .endif
         .while (ecx)
               mov     al, byte ptr[esi]
            .if al == 0dh
               .break
            .endif
               mov     byte ptr[edi], al
               dec     ecx
               inc     esi
               inc     edi
         .endw
            mov     byte ptr[edi], 0
         INVOKE     lstrcpy, addr szLoadPathP, addr szWork

         .if sw88   ; Refreash 
            INVOKE     lstrcpy, addr PathName, addr szWork
            INVOKE     lstrcat, addr PathName, addr szProjectP
            INVOKE     lstrcat, addr PathName, addr szAsm
         .endif

         INVOKE     ReadTheFile, addr szWork

FreeEm:
         INVOKE     GlobalUnlock, fpMem
         INVOKE     GlobalFree, hpMem
            mov     hpMem, 0
      .endif
         jmp     Ret0

;---------- [Delete Project] ----------
RightClk:
      INVOKE     GetCursorPos, addr pt
      INVOKE     ScreenToClient, hWndTreeP, addr pt
         mov     eax, pt.x
         mov     tvhti.pt.x, eax
         mov     eax, pt.y
         mov     tvhti.pt.y, eax
      INVOKE     SendMessage, hWndTreeP, TVM_HITTEST, 0, addr tvhti
      .if (tvhti.flags & TVHT_ONITEM)
         INVOKE     ClientToScreen, hWndTreeP, addr pt
            mov     tvi.imask, TVIF_HANDLE or TVIF_TEXT
            mov     eax, tvhti.hItem
            mov     tvi.hItem, eax
            lea     eax, szBuff1
            mov     tvi.pszText, eax
            mov     tvi.cchTextMax, 64
         INVOKE     SendMessage, hWndTreeP, TVM_GETITEM, 0, addr tvi
           test     eax,eax
            jz      Ret0
         INVOKE     MessageBox, NULL, addr szDeleteP, addr szBuff1, MB_YESNO or MB_ICONQUESTION
         .if eax == IDNO
               jmp     Ret0
         .endif

         INVOKE     LoadLibrary, addr LibNameCP
         .if eax
               mov     hCreate, eax
            INVOKE     GetProcAddress, eax, addr FuncNameDP
            .if eax
                 push     4444
                  lea     ecx, szBuff1
                 push     ecx
                 Push     offset szRedit
                 push     0
                 push     hwnd
                 call     eax
               .if eax == 4444    ; Delete confirmed
                     mov     DeleteSW, eax
                     mov     eax, hItemP
                  .if eax == tvhti.hItem
                     INVOKE     SendMessage, hWndListP, LVM_DELETEALLITEMS, 0, 0
                        and     hItemP, 0
                        mov     byte ptr szProjectP, 0
                  .endif
                  INVOKE     SendMessage, hWndTreeP, TVM_DELETEITEM, 0, tvhti.hItem

;---------- [Updated the hProjArray for the deleted item] ----------
                     mov     eax, tvhti.hItem
                     mov     esi, hProjArray
                     xor     edx, edx
                     mov     ecx, ProjCnt
                  .while (ecx)
                     .if dword ptr[esi+edx+4] == eax
mov     dword ptr[esi+edx+4], 0
mov     byte ptr[esi+edx+8], 0
                        .break
                     .endif
                        add     edx, 36
                        dec     ecx
                  .endw

;---------- [Select the active Tree item] ----------
                     mov     eax, hREdit
                     mov     esi, hProjArray
                     xor     edx, edx
                     mov     ecx, ProjCnt
                  .while (ecx)
                     .if dword ptr[esi+edx] == eax
                           xor     ebx, ebx
                           mov     eax, dword ptr[esi+edx+4]
                           mov     bl, byte ptr[esi+edx+8]
                        .break
                     .endif
                        add     edx, 36
                        dec     ecx
                  .endw
                  .if ecx && ebx == 1
                       push     eax
                     INVOKE     LockWindowUpdate, hWnd
                        pop     eax
                        mov     FromTab, 1
                     INVOKE     SendMessage, hWndTreeP, TVM_SELECTITEM, TVGN_CARET, eax
                        and     FromTab, 0
                     INVOKE     LockWindowUpdate, 0
                  .endif

               .endif
            .else
            .endif

            INVOKE     FreeLibrary, hCreate
               and     hCreate, 0
         .else
            MsgBox     ERROR_MISSING_DLL, LibNameCP, MB_OK or MB_ICONERROR
         .endif
      .endif
         jmp     Ret0

Ret0:
         xor     eax, eax   
         ret
TreeViewNotifyP endp

;-----------------------------------------------------------------------
TreeViewNotify proc uses ebx edx hwnd:DWORD, pnmtv
LOCAL    pshf:DWORD
LOCAL    pidl:DWORD
LOCAL    ptvobj:LPTV_OBJDATA
LOCAL    strret:STRRET
LOCAL    tvhti:TV_HITTESTINFO
LOCAL    tvi:TV_ITEM
LOCAL    sfi:SHFILEINFO
LOCAL    pt:POINT

         mov     eax, pnmtv
         mov     ebx, (NM_TREEVIEW ptr [eax]).itemNew.lParam 
         mov     ptvobj, ebx
         mov     eax, (NM_TREEVIEW ptr [eax]).hdr.code
         cmp     eax, TVN_ITEMEXPANDING
          je     item_expanding
         cmp     eax, TVN_SELCHANGED ;A
          je     sel_changed
         jmp     RetOk

;---------- [Item is expanding...] ----------
item_expanding:
         mov     ebx, pnmtv
        push     (NM_TREEVIEW ptr [ebx]).action
         pop     ExpCol

        test     (NM_TREEVIEW ptr [ebx]).itemNew.state, TVIS_EXPANDEDONCE 
         jnz     RetOk

         mov     ebx, ptvobj         
         mov     edx, (TV_OBJDATA ptr [ebx]).pshfParent
         mov     edx, [edx]
      INVOKE     (IShellFolder PTR [edx]).BindToObject, (TV_OBJDATA ptr [ebx]).pshfParent, 
                 (TV_OBJDATA ptr [ebx]).pidlRel, 0, addr IID_IShellFolder, addr pshf 
        test     eax, eax
          js     RetError                  

         mov     ebx, pnmtv
         mov     edx, ptvobj
      INVOKE     UpdateTreeView, hWndTree, pshf, (TV_OBJDATA ptr [edx]).pidlFull,\
                 (NM_TREEVIEW ptr [ebx]).itemNew.hItem

      .if Loaded
            mov     ebx, pnmtv
         INVOKE     SendMessage, hWndTree, TVM_SORTCHILDREN, 0, (NM_TREEVIEW ptr [ebx]).itemNew.hItem
            mov     ebx, pnmtv
         INVOKE     SendMessage, hWndTree, TVM_ENSUREVISIBLE, 0, (NM_TREEVIEW ptr [ebx]).itemNew.hItem
      .endif

         mov     eax, pshf
         mov     eax, [eax]
      INVOKE     (IShellFolder ptr [eax]).Release, pshf
         jmp     RetOk              

;---------- [Update list view header to give full path name] ----------
sel_changed:
      INVOKE     SHGetDesktopFolder, addr pshf
        test     eax, eax
          js     RetError


         mov     eax, pnmtv
        test     (NM_TREEVIEW ptr [eax]).action, TVIS_FOCUSED
          jz     Pass1
         mov     ecx, (NM_TREEVIEW ptr [eax]).itemNew.hItem
         mov     hItemP, ecx
         mov     tvi.hItem, ecx
         mov     tvi.imask, TVIF_TEXT or TVIF_SELECTEDIMAGE
         lea     eax, szProject
         mov     tvi.pszText, eax
         mov     tvi.cchTextMax, 64
      INVOKE     SendMessage, hWndTree, TVM_GETITEM, NULL, addr tvi
;        test     eax,eax
;          jz      Ret0

Pass1:
         mov     ebx, pnmtv
      INVOKE     SendMessage, hWndTree, TVM_ENSUREVISIBLE, 0, (NM_TREEVIEW ptr [ebx]).itemNew.hItem

         mov     ebx, ptvobj
         mov     edx, (TV_OBJDATA ptr [ebx]).pidlFull
      INVOKE     SHGetPathFromIDList, edx, addr WorkBuff
        test     eax,eax
;          jz     Pass ;RetError ;!!!!!!!!!!!!!!!!!!!!!!
.if WorkBuff
      INVOKE     lstrcpy, addr szLoadPath, addr WorkBuff
      INVOKE     lstrcat, addr szLoadPath, addr szSlashB
.endif

;---------- [Display the Path] ----------
      .if Loaded && ExpCol != 1
         INVOKE     ReadTheFile, addr szLoadPath
      .endif
Pass:
         and     ExpCol, 0
         mov     eax, pshf
         mov     eax, [eax]
      INVOKE     (IShellFolder ptr [eax]).Release, pshf
         jmp     RetOk              

RetOk:
         mov     eax, TRUE
         ret

RetError:
         xor     eax, eax   
         ret
TreeViewNotify endp

;-----------------------------------------------------------------------
IDList_GetSize proc uses ebx pidl:DWORD
LOCAL    cbTotal:DWORD

         mov     cbTotal, 0
      .if pidl != 0
            mov     ebx, pidl

StartLoop:
          movsx     eax, (ITEMIDLIST PTR [ebx]).mkid.cb
           test     eax, eax
             jz     EndLoop
            add     cbTotal, eax
            add     ebx, eax
            jmp     StartLoop

EndLoop:                                   
      .endif       
         mov     eax, cbTotal    
         ret
IDList_GetSize endp

;-----------------------------------------------------------------------
IDList_CopyItem  proc uses ebx edx ecx edi esi pidl:DWORD
LOCAL    pidlNew:DWORD
LOCAL    sz:DWORD
      
         mov     ebx, pidl 
        movsx    edx, (ITEMIDLIST PTR [ebx]).mkid.cb
         add     edx, sizeof WORD
         mov     sz, edx
        
         mov     edx, pShellMalloc
         mov     edx, [edx]
      INVOKE     (IMalloc PTR [edx]).Alloc, pShellMalloc, sz
      
        test     eax, eax
          jz     Ret0
         mov     pidlNew, eax

         mov     esi, pidl
         mov     edi, pidlNew
         mov     ecx, sz
      .while (ecx)
            mov     al, byte ptr [esi]
            mov     byte ptr [edi], al       
            dec     ecx            
            inc     esi
            inc     edi
      .endw
      
RetOk: 
         mov     eax, pidlNew
         ret
      
Ret0:
         xor          eax, eax
         ret        
IDList_CopyItem  endp

;-----------------------------------------------------------------------
IDList_Combine proc uses esi edi ecx edx pidl1:DWORD, pidl2
LOCAL    pidlNew:DWORD
LOCAL    comb1:DWORD
LOCAL    comb2:DWORD
      
;---------- [Get length of 1st pidl (not including NULL terminating word)] ----------
      INVOKE     IDList_GetSize, pidl1
         mov     comb1, eax
      
;---------- [Get length of 2nd pidl (not including NULL terminating word)] ----------
      INVOKE     IDList_GetSize, pidl2
         mov     comb2, eax
      
;---------- [Get total length of resulting combined pidl (including NULL terminating word)] ----------
         mov     eax, sizeof ITEMIDLIST.mkid.cb
         add     eax, comb1
         add     eax, comb2  
        
;---------- [Allocate the memory] ----------
         mov     edx, pShellMalloc
         mov     edx, [edx]
      INVOKE     (IMalloc PTR [edx]).Alloc, pShellMalloc, eax
      
        test     eax, eax
          jz     RetError
         mov     pidlNew, eax
         mov     edi, eax
      
;---------- [Write 1st pidl to destination (pidlNew)] ----------
         mov     esi, pidl1
         mov     ecx, comb1
      .while (ecx)
            mov     al, byte ptr [esi]
            mov     byte ptr [edi], al
            dec     ecx            
            inc     esi
            inc     edi
      .endw             

;---------- [Write 2nd pidl after 1st] ----------
         mov     esi, pidl2
         mov     ecx, comb2
      .while (ecx)
            mov     al, byte ptr [esi]
            mov     byte ptr [edi], al       
            dec     ecx            
            inc     esi
            inc     edi
      .endw             
      
;---------- [Add terminating word] ----------
         mov     word ptr [edi], 0
         mov     eax, pidlNew
         ret

RetError:
         int     3
         xor     eax, eax
         ret        
IDList_Combine   endp

;-----------------------------------------------------------------------
; dwType = SHGFI_OPENICON or SHGFI_ICON
GetIcon proc uses edx pidl:DWORD, dwType
LOCAL    shfi:SHFILEINFO
        
         mov     edx, SHGFI_PIDL or SHGFI_SYSICONINDEX or SHGFI_SMALLICON
          or     edx, dwType

;---------- [SHGetfileinfo requires full pidl] ----------
      INVOKE     SHGetFileInfo, pidl, 0, addr shfi, sizeof SHFILEINFO, edx
         mov     eax, shfi.iIcon
         ret
GetIcon endp

;========================================================================
; Expand Tree to proper branch converts a path to a tree handle PROCEDURE
;========================================================================
TreeBranch proc uses ebx esi  LoadPath:DWORD
LOCAL    tvi:TV_ITEM
LOCAL    LevelCnt:DWORD, Cnt, CntL, dwState, Match
LOCAL    szPath[256]:byte, szWork[64], szBuff[64]

      INVOKE     LockWindowUpdate, hWnd           ; Lock parent to avoid flicker

      INVOKE     SendMessage, hWndTree, TVM_GETNEXTITEM, TVGN_ROOT, 0
      .if !eax
            ret
      .endif
         mov     hItem, eax
         and     CntL, 0
         and     Match, 0
      INVOKE     lstrcpy, addr szPath, LoadPath

;---------- [Get the first path level] ----------
         lea     esi, szPath
         mov     LevelCnt, 1
      .while (byte ptr[esi]) != 0
         .if byte ptr[esi] == '\'
               add     LevelCnt, 1
         .endif
         inc     esi
      .endw

         xor     eax, eax
         lea     esi, szPath
      .while (byte ptr[esi]) != 0
         .if byte ptr[esi] == '\'
               inc     eax
            INVOKE     lstrcpyn, addr szBuff, addr szPath, eax
               inc     esi
            INVOKE     lstrcpy, addr szPath, esi
            .break
         .endif
         inc     eax
         inc     esi
      .endw
         mov     dwState, TVIS_BOLD

;---------- [Get the drive handle from the drive letter] ----------
      .if byte ptr szBuff >= 'A' && byte ptr szBuff <= 'Z'
            add     byte ptr szBuff, 20h
      .endif
         and     Cnt, 0
      INVOKE     lstrlen, addr szDrvLet
         mov     ecx, eax
         xor     eax, eax
         mov     dl, byte ptr szBuff
      .while (ecx)
         .if dl == byte ptr szDrvLet+[eax]
            .break
         .endif
            inc     eax
            dec     ecx
      .endw
      .if ecx
         .if eax
               dec     eax
         .endif
            mov     edx, hDrives+[eax*4]
            mov     hItem, edx
         INVOKE     SendMessage, hWndTree, TVM_EXPAND, TVE_EXPAND, hItem
            jmp     NextLev
      .else
         INVOKE     MessageBox, NULL, addr szError3, addr szLoadPath, MB_OK or MB_ICONINFORMATION
            ret
      .endif
         xor     ebx, ebx

;---------- [Use the path to expand the tree] ----------
      .while (ebx < LevelCnt)
         .if byte ptr szPath == 0   ; Last level
               and     Match, 0
               mov     dwState, TVIS_SELECTED or TVIS_BOLD
            INVOKE     lstrcpy, addr szProject, addr szBuff
         .endif

;------------------- [First item of tree] -------------------
         INVOKE     SendMessage, hWndTree, TVM_GETNEXTITEM, TVGN_CHILD, hItem
           test     eax, eax
             jz     ret_ok
            mov     hItem, eax
          MOVmd     tvi.hItem, hItem
            mov     tvi.imask, TVIF_TEXT
            lea     eax, szWork
            mov     tvi.pszText, eax
            mov     tvi.cchTextMax, 64
         INVOKE     SendMessage, hWndTree, TVM_GETITEM, NULL, addr tvi
         INVOKE     lstrcmpi, addr szWork, addr szBuff
         .if eax == 0
             MOVmd     tvi.hItem, hItem
               mov     tvi.imask, TVIF_STATE
             MOVmd     tvi.state, dwState ;TVIS_SELECTED
               mov     tvi.stateMask, 000000ffh
            INVOKE     SendMessage, hWndTree, TVM_SETITEM, NULL, addr tvi
            INVOKE     SendMessage, hWndTree, TVM_EXPAND, TVE_EXPAND, hItem
               inc     Match
               jmp     NextLev
         .endif

;------------------- [Greater then first item of tree] -------------------
         INVOKE     SendMessage, hWndTree, TVM_GETNEXTITEM, TVGN_NEXT, hItem
         .while (eax != 0) 
               mov     hItem, eax
             MOVmd     tvi.hItem, hItem
               mov     tvi.imask, TVIF_TEXT
               lea     eax, szWork
               mov     tvi.pszText, eax
               mov     tvi.cchTextMax, 64
            INVOKE     SendMessage, hWndTree, TVM_GETITEM, NULL, addr tvi
            INVOKE     lstrcmpi, addr szWork, addr szBuff
            .if eax == 0
                MOVmd     tvi.hItem, hItem
                  mov     tvi.imask, TVIF_STATE
                MOVmd     tvi.state, dwState ;TVIS_SELECTED
                  mov     tvi.stateMask, 000000ffh
               INVOKE     SendMessage, hWndTree, TVM_SETITEM, NULL, addr tvi
               INVOKE     SendMessage, hWndTree, TVM_EXPAND, TVE_EXPAND, hItem
                  inc     Match
               .break
            .endif
            INVOKE     SendMessage, hWndTree, TVM_GETNEXTITEM, TVGN_NEXT, hItem
         .endw

;------------------- [Get the directory for the next level] -------------------
NextLev:
         .if byte ptr szPath == 0 && Match
            INVOKE     SendMessage, hWndTree, TVM_SELECTITEM, TVGN_FIRSTVISIBLE, hItem
            INVOKE     SendMessage, hWndTree, TVM_SELECTITEM, TVGN_CARET, hItem
               jmp     ret_ok
         .elseif byte ptr szPath == 0 && !Match
            INVOKE     MessageBox, NULL, addr szError3, addr szLoadPath, MB_OK or MB_ICONINFORMATION
               jmp     ret_ok
         .endif
            mov     szBuff, 0
            xor     eax, eax
            lea     esi, szPath
         .while (byte ptr[esi]) != 0
            .if byte ptr[esi] == '\'
                  inc     eax
               INVOKE     lstrcpyn, addr szBuff, addr szPath, eax
                  inc     esi
               INVOKE     lstrcpy, addr szPath, esi
               .break
            .endif
            inc     eax
            inc     esi
         .endw
         .if byte ptr szBuff == 0
               jmp     ret_ok
         .endif
            add     CntL, 1
            mov     ebx, CntL
      .endw

ret_ok:
      INVOKE     LockWindowUpdate, 0              ; Unock parent

         ret
TreeBranch endp

END
;INVOKE     MessageBox, NULL, addr szPath, addr AppName, MB_OK
